<!-- Linea 1 -->
<app-header></app-header>

  <!-- Linea 2 --> <!-- Linea 7 -->
  <div class="container wrap">
    <!-- Linea 6-->
    <router-outlet></router-outlet>
    <!-- Linea 4 -->
    <!-- <app-directiva></app-directiva> -->
    <!-- Linea 5 -->
    <!-- <app-clientes></app-clientes> -->
  </div>

<!-- Linea 3 -->
<app-footer></app-footer>

<!--------------------------------------------------------------------------------------------------->
<!-- Tarea  5 -->
  <!-- Linea 1: Poner el selector del header-component -->
  <!-- Linea 2: Crear container del contenido principal del proyecto -->

<!-- Tarea 10 -->
  <!-- Linea 3: Poner el selector del footer-component -->

<!-- Tarea 14 -->
  <!-- Linea 4: Poner el selector del directiva-component -->

<!-- Tarea 22 -->
  <!-- Linea 5: Poner el selector del clientes-component -->

<!-- Tarea 33 -->
  <!-- Linea 6: Poner el selector del enrutador -->

<!-- Tarea 84 -->
  <!-- Linea 7: Ponerle un padding al container por medio de la clase "wrap" -->

<!--------------------------------------------------------------------------------------------------->
<!-- Procesos del Proyecto Completo -->
  <!-- Proceso 1: Configurar bootstrap en el proyecto -->
    <!-- Tarea  1: Archivo src/index.html -->

  <!-- Proceso 2: Maquetado inicial del proyecto -->
    <!-- Tarea  2: Crear el componente header-component -->
    <!-- Tarea  3: Archivo app/header/header.component.ts -->
    <!-- Tarea  4: Archivo app/header/header.component.html -->
    <!-- Tarea  5: Archivo app/app.component.html -->
    <!-- Tarea  6: Crear el componente footer-component -->
    <!-- Tarea  7: Archivo app/footer/footer.component.ts -->
    <!-- Tarea  8: Archivo app/footer/footer.component.html -->
    <!-- Tarea  9: Archivo app/footer/footer.component.less -->
    <!-- Tarea 10: Archivo app/app.component.html -->

  <!-- Proceso 3: Trabajar con directivas ngIf y ngFor -->
    <!-- Tarea 11: Crear el componente directiva -->
    <!-- Tarea 12: Archivo app/directiva/directiva.component.ts -->
    <!-- Tarea 13: Archivo app/directiva/directiva.component.html -->
    <!-- Tarea 14: Archivo app/app.component.html -->
    <!-- Tarea 15: Archivo app/directiva/directiva.component.ts -->
    <!-- Tarea 16: Archivo app/directiva/directiva.component.html -->

  <!-- Proceso 4: Trabajar el listado de clientes -->
    <!-- Tarea 17: Crear componente clientes -->
    <!-- Tarea 18: Crear clase cliente -->
    <!-- Tarea 19: Archivo app/clientes/cliente -->
    <!-- Tarea 20: Archivo app/clientes/clientes.component.ts -->
    <!-- Tarea 21: Archivo app/clientes/clientes.component.html -->
    <!-- Tarea 22: Archivo app/app.component.html -->
    <!-- Tarea 23: Crear archivo json de clientes -->
    <!-- Tarea 24: Archivo app/clientes/clientes.json.ts -->
    <!-- Tarea 25: Archivo app/clientes/clientes.component.ts -->
    <!-- Tarea 26: Crear servicio cliente -->
    <!-- Tarea 27: Archivo app/clientes/cliente.service.ts -->
    <!-- Tarea 28: Archivo app/clientes/clientes.component.ts -->
    <!-- Tarea 29: Archivo app/app.module.ts -->
    <!-- Tarea 30: Archivo app/clientes/cliente.service.ts -->
    <!-- Tarea 31: Archivo app/clientes/clientes.component.ts -->

  <!-- Proceso 5: Implementando las rutas del proyecto -->
    <!-- Tarea 32: Archivo app/app-routing.module.ts -->
    <!-- Tarea 33: Archivo app/app.component.html -->
    <!-- Tarea 34: Archivo app/header/header.component.ts -->

  <!-- Proceso 6: Formas de instalar bootstrap -->
    <!-- Tarea 35: https://www.udemy.com/course/angular-spring/learn/lecture/11992156#content -->
    <!-- Tarea 36: https://www.udemy.com/course/angular-spring/learn/lecture/11992162#content -->

  <!-- Proceso 7: Creacion del proyecto en spring boot -->
    <!-- Tarea 37-A: https://www.udemy.com/course/angular-spring/learn/lecture/15335982#content -->
    <!-- Tarea 37-B: https://www.udemy.com/course/angular-spring/learn/lecture/11992308#content -->

  <!-- Proceso 15: Comunicacion con el back-end -->
    <!-- Tarea 57: Archivo app/app.module.ts -->
    <!-- Tarea 58: Archivo app/clientes/cliente.service.ts -->

  <!-- Proceso 17: Creacion del CRUD -->
    <!-- Tarea 63: Crear componente from -->
    <!-- Tarea 64: Archivo app/app.module.ts -->
    <!-- Tarea 65: Archivo app/clientes/form.component.ts -->
    <!-- Tarea 66: Archivo app/clientes/form.component.html -->
    <!-- Tarea 67: Archivo app/app-routing.module.ts -->
    <!-- Tarea 68: Archivo app/clientes/clientes.component.html -->
    <!-- Tarea 69: Archivo app/clientes/cliente.service.ts -->
    <!-- Tarea 70: Archivo app/clientes/form.component.ts -->
    <!-- Tarea 71: Instalar sweetalert https://sweetalert2.github.io/ "npm install sweetalert2 --save" -->
    <!-- Tarea 72: Archivo app/clientes/form.component.ts -->
    <!-- Tarea 73: Archivo app/clientes/cliente.service.ts -->
    <!-- Tarea 74: Archivo app/clientes/form.component.ts -->
    <!-- Tarea 75: Archivo app/app.module.ts -->
    <!-- Tarea 76: Archivo app/clientes/form.component.html -->
    <!-- Tarea 77: Archivo app/clientes/cliente.service.ts -->
    <!-- Tarea 78: Archivo app/clientes/form.component.ts -->
    <!-- Tarea 79: Archivo app/clientes/form.component.html -->
    <!-- Tarea 80: Archivo app/clientes/cliente.service.ts  -->
    <!-- Tarea 81: Archivo app/clientes/clientes.component.ts -->
    <!-- Tarea 82: Archivo app/clientes/clientes.component.html -->
    <!-- Tarea 83: Archivo src/styles.less -->
    <!-- Tarea 84: Archivo app/app.component.html -->
    <!-- Tarea 85: Archivo app/clientes/clientes.component.html  -->

  <!-- Proceso 19: Manejo de errores -->
    <!-- Tarea 87: Archivo app/clientes/cliente.service.ts -->
    <!-- Tarea 88: Archivo app/clientes/form.component.html -->
    <!-- Tarea 91: Archivo app/clientes/cliente.service.ts -->
    <!-- Tarea 92: Archivo app/clientes/form.component.ts -->
    <!-- Tarea 93: Archivo app/clientes/form.component.html -->

 <!-- Proceso 20: Modificaciones de diseño, Mayusculas, Fechas -->
    <!-- Tarea 95: Archivo app/clientes/cliente.service.ts -->
    <!-- Tarea 96: Archivo app/app.module -->
    <!-- Tarea 97: Archivo app/clientes/clientes.component.html  -->
    <!-- Tarea 98: Archivo app/app.module.ts -->
    <!-- Tarea 99: Archivo app/clientes/cliente.service.ts -->
    <!-- Tarea 100: Archivo app/clientes/form.component.ts -->

  <!-- Proceso 22: Moficaciones en el front End para la paginacion -->
    <!-- Tarea 105: Archivo app/clientes/cliente.service.ts -->
    <!-- Tarea 106: Archivo app/clientes/clientes.component.ts -->
    <!-- Tarea 107: Archivo app/app-routing.module.ts -->
    <!-- Tarea 108: Archivo app/clientes/clientes.component.ts-->
    <!-- Tarea 109: Crear el componente paginator -->
    <!-- Tarea 110: Archivo app/clientes/clientes.component.ts -->
    <!-- Tarea 111: Archivo app/clientes/clientes.component.html -->
    <!-- Tarea 112: Archivo app/paginator/paginator.component.ts -->
    <!-- Tarea 113: Archivo app/paginator/paginator.component.html -->
    <!-- Tarea 114: Archivo app/paginator/paginator.component.ts -->
    <!-- Tarea 115: Archivo app/paginator/paginator.component.ts -->

  <!-- Proceso 24: Implementacion del control de fecha en el Front-End -->
    <!-- Tarea 118: Instalar Angular Material: ng add @angular/material -->
    <!-- Tarea 119: Instalar el Moment Adapter: npm install --save @angular/material-moment-adapter -->
    <!--            Instalar el Moment Adapter: npm install --save moment -->
    <!-- Tarea 120: Archivo app/app.module.ts -->
    <!-- Tarea 121: Archivo app/clientes/form.component.html -->

  <!-- Proceso 26: Trabajar con la subida de imagenes -->
    <!-- Tarea 127: Crear el componente detalle-cliente dentro de la carpeta app/clientes -->
    <!-- Tarea 128: Archivo app/clientes/detalle/detalle.component.ts -->
    <!-- Tarea 129: Archivo app/clientes/detalle/detalle.component.html -->
    <!-- Tarea 130: Archivo app/app-routing.module.ts -->
    <!-- Tarea 131: Archivo app/clientes/clientes.component.html -->
    <!-- Tarea 132: Archivo app/clientes/cliente.ts -->
    <!-- Tarea 133: Archivo app/clientes/cliente.service.ts -->
    <!-- Tarea 134: Archivo app/clientes/detalle/detalle.component.ts -->
    <!-- Tarea 135: Archivo app/clientes/detalle/detalle.component.html -->
    <!-- Tarea 136: Archivo app/clientes/cliente.service.ts -->
    <!-- Tarea 137: Archivo app/clientes/detalle/detalle.component.ts -->
    <!-- Tarea 138: Archivo app/clientes/detalle/detalle.component.html -->
    <!-- Tarea 139: Crear la clase Modal Service -->
    <!-- Tarea 140: Archivo app/clientes/detalle/modal.service.ts -->
    <!-- Tarea 141: Archivo app/clientes/clientes.component.ts -->
    <!-- Tarea 142: Archivo app/clientes/detalle/detalle.component.ts -->
    <!-- Tarea 143: Archivo app/clientes/clientes.component.html -->
    <!-- Tarea 144: Archivo app/clientes/detalle/detalle.component.html -->
    <!-- Tarea 145: Archivo app/clientes/detalle/detalle.component.less -->
    <!-- Tarea 146: Archivo app/clientes/detalle/detalle.component.html -->
    <!-- Tarea 147: Archivo app/clientes/clientes.component.html -->
    <!-- Tarea 148: Archivo app/clientes/detalle/modal.service.ts -->
    <!-- Tarea 149: Archivo app/clientes/detalle/detalle.component.ts -->
    <!-- Tarea 150: Archivo app/clientes/clientes.component.ts -->

  <!-- Proceso 29: Trabajar con las regiones -->
    <!-- Tarea 164: Crear la clase region -->
    <!-- Tarea 165: Archivo app/clientes/region.ts -->
    <!-- Tarea 166: Archivo app/clientes/cliente.ts -->
    <!-- Tarea 167: Archivo app/clientes/detalle/detalle.component.html -->
    <!-- Tarea 168: Archivo app/clientes/cliente.service.ts -->
    <!-- Tarea 169: Archivo app/clientes/form.component.ts -->
    <!-- Tarea 170: Archivo app/clientes/form.component.html -->
    <!-- Tarea 171: Archivo app/clientes/form.component.ts -->

  <!-- Proceso 32: Trabajar con el login -->
    <!-- Tarea 202: Crear el directorio usuarios y dentro de este crear el componente login -->
    <!-- Tarea 203: Archivo app/app-routing.module.ts -->
    <!-- Tarea 204: Archivo app/usuarios/login.component.ts -->
    <!-- Tarea 205: Archivo app/usuarios/login.component.html -->
    <!-- Tarea 206: Archivo app/header/header.component.ts -->
    <!-- Tarea 207: Archivo app/clientes/cliente.service.ts -->
    <!-- Tarea 208: Crear la clase Usuario -->
    <!-- Tarea 209: Archivo app/usuarios/usuario.ts -->
    <!-- Tarea 210: Archivo app/usuarios/login.component.ts -->
    <!-- Tarea 211: Archivo app/usuarios/login.component.html -->
    <!-- Tarea 212: Crear el servicio auth -->
    <!-- Tarea 213: Archivo app/usuarios/auth.service.ts -->
    <!-- Tarea 214: Archivo app/usuarios/login.component.ts -->
    <!-- Tarea 215: Archivo app/header/header.component.ts -->
    <!-- Tarea 216: Archivo app/header/header.component.html -->

  <!-- Proceso 33: Habilitar o desabilitar deacuerdo a permisos -->
    <!-- Tarea 217: Archivo app/clientes/cliente.service.ts -->
    <!-- Tarea 218: Archivo app/clientes/cliente.component.html -->
    <!-- Tarea 219: Archivo app/clientes/detalle/detalle.component.ts -->
    <!-- Tarea 220: Archivo app/clientes/detalle/detalle.component.html -->
    <!-- Tarea 221: Archivo app/clientes/cliente.service.ts -->
    <!-- Tarea 222: Creamos un nuevo guard llamado auth -->
    <!-- Tarea 223: Archivo app/usuarios/guards/auth.guard.ts -->
    <!-- Tarea 224: Archivo app/app-routing.module.ts -->
    <!-- Tarea 225: Creamos un nuevo guard llamado role -->
    <!-- Tarea 226: Archivo app/usuarios/guards/role.guard.ts -->
    <!-- Tarea 227: Archivo app/app-routing.module.ts -->
    <!-- Tarea 228: Archivo app/usuarios/guards/auth.guard.ts -->
    <!-- Tarea 229: Crear la clase interceptors token -->
    <!-- Tarea 230: Archivo app/usuarios/interceptors/token.interceptor.ts -->
    <!-- Tarea 231: Archivo app/app.module.ts -->
    <!-- Tarea 232: Crear la clase interceptors auth -->
    <!-- Tarea 233: Archivo app/usuarios/interceptors/auth.interceptor.ts -->
    <!-- Tarea 234: Archivo app/clientes/cliente.service.ts -->
    <!-- Tarea 235: Archivo app/app.module.ts -->

  <!-- Proceso 35: Trabajar con las facturas -->
    <!-- Tarea 248: Crear las clases app/facturas/models/factura.ts, item-factura.ts, producto.ts -->
    <!-- Tarea 249: Archivo app/facturas/models/producto.ts -->
    <!-- Tarea 250: Archivo app/facturas/models/item-factura.ts -->
    <!-- Tarea 251: Archivo app/facturas/models/factura.ts -->
    <!-- Tarea 252: Archivo app/clientes/cliente.ts -->
    <!-- Tarea 253: Archivo app/clientes/detalle/detalle.component.html -->
    <!-- Tarea 254: Crear el componente Detalle Factura -->
    <!-- Tarea 225: Archivo app/app-routing.module.ts -->
    <!-- Tarea 256: Creamos el service detelle de factura -->
    <!-- Tarea 257: Archivo app/facturas/services/facturas.service.ts -->
    <!-- Tarea 258: Archivo app/facturas/detalle-factura.component.ts -->
    <!-- Tarea 259: Archivo app/facturas/detalle-factura.component.html -->
    <!-- Tarea 260: Archivo app/facturas/services/facturas.service.ts -->
    <!-- Tarea 261: Archivo app/clientes/detalle/detalle.component.ts -->
    <!-- Tarea 262: Archivo app/clientes/detalle/detalle.component.html -->
    <!-- Tarea 263: Crear componente facturas -->
    <!-- Tarea 264: Archivo app/app-routing.module.ts -->
    <!-- Tar 175, 180 -->
    <!-- Tarea 265: Archivo app/facturas/facturas.component.ts -->
    <!-- Tarea 266: Archivo app/clientes/cliente.component.html -->
    <!-- Tarea 267: Archivo app/clientes/detalle/detalle.component.html -->
    <!-- Tarea 268: Archivo app/facturas/facturas.component.html -->

  <!-- Proceso 37: Preparar el Front-End para el Deploy -->
    <!-- Tarea 273: Archivo app/clientes/cliente.component.ts -->
    <!-- Tarea 274: Archivo app/clientes/detalle/detalle.component.ts -->
    <!-- Tarea 215: Archivo app/header/header.component.ts -->
    <!-- Tarea 216: Archivo app/facturas/facturas.component.ts -->
<!--------------------------------------------------------------------------------------------------->
